#include <def2191.h>
#include "def2191bit.h"
#include <sysreg.h>
#include <signal.h>

#define BUFSIZE 6

struct TDMADescriptor 
{
	int configuration, startPage, startAddress, count;
	struct TDMADescriptor * nextDescriptor;
};

int rxBuffer[BUFSIZE*2];
struct TDMADescriptor  rxTCB1, rxTCB2;

void sportRxHandler( int sig );
void setupSport( void );
void setupTCB( void );
void reset1885( void );

int main(void)
{
	reset1885( );
	interrupt( SIG_INT5, sportRxHandler );		// SIG_INT5 is default interupt for SPORT0 RX
    enable_interrupts();                 // O[o荞݃Cl[u
	setupTCB();									// TCB Configuratoin
	setupSport();								// SPORT0 RX Configuration
	while ( 1 )
		;
}

void setupSport( void )
{

	sysreg_write( sysreg_IOPG, SPORT0_Controller_Page );
	io_space_write( SP0DR_CFG, 0 );		// RX DMA Disable
	io_space_write( SP0_RCR, 0 );		// RX disable
	io_space_write( SP0_TCR, 0 );		// TX disable

	io_space_write( SP0_RFSDIV, 255 );		// 256 bit per frame
	io_space_write( SP0_MRCS0, 0x003f );	// only 6 channel
	io_space_write( SP0_MRCS1, 0 );	
	io_space_write( SP0_MRCS2, 0 );	
	io_space_write( SP0_MRCS3, 0 );	
	io_space_write( SP0_MRCS4, 0 );	
	io_space_write( SP0_MRCS5, 0 );	
	io_space_write( SP0_MRCS6, 0 );	
	io_space_write( SP0_MRCS7, 0 );	

	io_space_write( SP0_MCMC1, 0 << WOFF_OFST | 1 << WSIZE_OFST | 1 << MFD_OFST | MCM );
	io_space_write( SP0_MCMC2, MCDRXPE );

	io_space_write( SP0DR_CP, (int) &rxTCB1 );	// set chain pointer
	io_space_write( SP0DR_CPR, 1 );		// ready descriptor pointer
	io_space_write( SP0DR_CFG, DEN );
	io_space_write( SP0_RCR,  IRFS | SLEN_16 | RSPEN );
}

void setupTCB( void )
{
			// setting up the DMA TCB1
	rxTCB1.configuration = DOWN | DCOME | TRAN | DEN;
	rxTCB1.startPage = 0;
	rxTCB1.startAddress = (int)rxBuffer;
	rxTCB1.count = BUFSIZE;
	rxTCB1.nextDescriptor = &rxTCB2;
			// setting up the DMA TCB2
	rxTCB2.configuration = DOWN | DCOME | TRAN | DEN;
	rxTCB2.startPage = 0;
	rxTCB2.startAddress = (int)&rxBuffer[BUFSIZE];
	rxTCB2.count = BUFSIZE;
	rxTCB2.nextDescriptor = &rxTCB1;
}

int count = 0;
void sportRxHandler( int sig )
{

	sysreg_write( sysreg_IOPG, SPORT0_Controller_Page );
	io_space_write( SP0DR_IRQ, 1 );		// clear interrupt from SP0 RX

	if ( !( rxTCB1.configuration & DOWN ) )	// Descriptor2 Finish?
		rxTCB1.configuration |= DOWN;	// give ownership of TCB1 to DMA engine.
	else
		rxTCB2.configuration |= DOWN;	// give ownership of TCB2 to DMA engine.

	count ++;
}

void reset1885( void )
{
		int curDIR, curIOPG, i;
	
		curIOPG = sysreg_read( sysreg_IOPG );
		sysreg_write( sysreg_IOPG, General_Purpose_IO );
		curDIR = io_space_read( DIR );				// get the current Direction Setting
		io_space_write( DIR, curDIR | 0x0080 );		// set PF7 output ( AD1885 /reset )
		io_space_write( FLAGC, 0x0080 );			// asseart /reset_ad1885
		for ( i=0; i<160; i++ )
			asm volatile( "nop;" );
		io_space_write( FLAGS, 0x0080 );			// asseart /reset_ad1885
		sysreg_write( sysreg_IOPG, curIOPG );
}

